<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRow(modalDatos)" class="btn btn-primary">
    <i class="fa fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="!dataGrid">
    <i class="far fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="card">
  <div class="card-body">

    <kendo-grid [kendoGridBinding]="dataGrid"
                [pageSize]="pageSize"
                [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}"
                [filter]="filter"
                [filterable]="true"
                [selectable]="true"
                [navigable]="true"
                [reorderable]="true"
                [resizable]="true"
                [sort]="sort"
                [sortable]="true"
                [groupable]="false"
                [group]="groups"
                (edit)="editRow($event, modalDatos)"
                (remove)="deleteRow($event)"
                style="height: 68vh;"
                *ngIf="!loading">
      <ng-container *ngIf="dataGrid.length !== 0">
        <ng-container *ngFor="let item of gridFields">
          <kendo-grid-column [field]="item.dataKey" [title]="item.title" [width]="item.width"
            [filterable]="item.filtro">
          </kendo-grid-column>
        </ng-container>
        <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
          <ng-template kendoGridCellTemplate let-dataItem>
            <input type="checkbox" [checked]="dataItem.Inactivo" [readOnly]="true" />
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-command-column title="Acciones" width="190">
          <ng-template kendoGridCellTemplate let-isNew="isNew">
            <button kendoGridEditCommand [primary]="true">Editar</button>
            <button kendoGridRemoveCommand>Eliminar</button>
          </ng-template>
        </kendo-grid-command-column>
      </ng-container>
      <ng-template kendoGridNoRecordsTemplate>
        {{ norecords }}
      </ng-template>
    </kendo-grid>

    <app-loading *ngIf="loading"></app-loading>

  </div>
</div>

<ng-template #modalDatos let-c="close" let-d="dismiss">
  <div class="modal-header">
    <h6 class="modal-title" *ngIf="!flagEdit">Nuevo</h6>
    <h6 class="modal-title" *ngIf="flagEdit">Editar</h6>
    <button class="close" aria-label="Close" (click)="d('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <form [formGroup]="myFormGroup">
      <div class="form-row">
        <div class="form-group col-4 col-sm-3 col-lg-2">
          <label>Código</label>
          <input type="text" class="form-control" formControlName="rreqesp" [readOnly]="flagEdit"
          maxlength="6">
        </div>
        <div class="form-group col-8 col-sm-6 col-lg-5">
          <label>Descripción</label>
          <input type="text" class="form-control" formControlName="rdesc" maxlength="30"
          maxlength="30">
        </div>
        <div class="form-group col-3 col-sm-2 col-lg-2">
          <label class="w-100">Inactivo</label>
          <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'">
          </kendo-switch>
        </div>
      </div>

      <div class="form-row">
        <div class="form-group col-md-3">
          <label>Depto. Acción</label>
          <kendo-combobox formControlName="depto" class="form-control" [data]="arrDeptos" [textField]="'ddesc'"
            [valueField]="'depto'" [(ngModel)]="deptoSelectedItem">
          </kendo-combobox>
        </div>
        <div class="form-group col-md-3">
          <label>Depto. Seg.</label>
          <kendo-combobox formControlName="deptose" class="form-control" [data]="arrDeptos" [textField]="'ddesc'"
            [valueField]="'depto'" [(ngModel)]="deptoseSelectedItem">
          </kendo-combobox>
        </div>
        <div class="form-group col-md-3">
          <label>Depto. Sat.</label>
          <kendo-combobox formControlName="deptosa" class="form-control" [data]="arrDeptos" [textField]="'ddesc'"
            [valueField]="'depto'" [(ngModel)]="deptosaSelectedItem">
          </kendo-combobox>
        </div>
        <div class="form-group col-md-3">
          <label>Grupo</label>
          <kendo-combobox formControlName="reqgrp" class="form-control" [data]="arrGrupos" [textField]="'rdesc'"
            [valueField]="'Reqgrp'" [(ngModel)]="reqgrpSelectedItem">
          </kendo-combobox>
        </div>
      </div>
      <div class="row d-flex justify-content-between">
        <div class="col-12 col-sm-7 col-lg-6">
          <div class="row">
            <div class="form-group col-4 col-sm-3 col-lg-3">
              <label class="w-100">Costo</label>
              <kendo-switch formControlName="rcosto" [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </div>
            <div class="form-group col-7 col-sm-8 col-lg-8">
              <label>Código Cargo</label>
              <kendo-combobox [data]="dsCodigos" [textField]="'cdesc'" [valueField]="'Codigo'" formControlName="codigo"
                [valuePrimitive]="true" class="form-control" [readonly]="!myFormGroup.value.rcosto">
              </kendo-combobox>
            </div>
          </div>
          <div class="row">
            <div class="form-group col-4 col-sm-3 col-lg-3">
              <label class="w-100">Disp.</label>
              <kendo-switch formControlName="rdisp" [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </div>

            <div class="form-group col-7 col-sm-8 col-lg-8">
              <label>Inventario</label>
              <input type="number" class="form-control" formControlName="rtotal" max="999999" min="0">
            </div>
          </div>
          <div class="row">
            <div class="form-group col-4 col-sm-3 col-lg-3">
              <label class="w-100">Cuarto</label>
              <kendo-switch formControlName="rcto" [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </div>

            <div class="form-group col-7 col-sm-6 col-lg-6">
              <label>Trabajo</label>
              <kendo-combobox formControlName="Trabajo" class="form-control" [data]="arrTrabajo" [textField]="'tdesc'"
                [valueField]="'trabajo'" [(ngModel)]="selectedItem">
              </kendo-combobox>
            </div>

            <div class="form-group col-4 col-sm-3 col-lg-2">
              <label>Duración</label>
              <input type="text" class="form-control" formControlName="rdur">
            </div>
          </div>
        </div>
        <div class="col-5 col-sm-4 col-lg-3">
          <div class="form-group col">
            <strong>Opción</strong>
          </div>
          <div class="form-group col">
            <input type="checkbox" formControlName="opt1">
            <label class="ml-2">Reservaciones</label>
          </div>
          <div class="form-group col">
            <input type="checkbox" formControlName="opt2">
            <label class="ml-2">Recepción</label>
          </div>
          <div class="form-group col">
            <input type="checkbox" formControlName="opt3">
            <label class="ml-2">Ama de Llaves</label>
          </div>
        </div>
        <div class="col-5 col-sm-4 col-lg-3">
          <div class="row">
            <div class="form-group col-md-3">
              <span>&nbsp;</span>
            </div>
            <div class="form-group col-md-3 text-center">
              <span>Utilizo</span>
            </div>
            <div class="form-group col-md-3 text-center">
              <span>Operador</span>
            </div>
            <div class="form-group col-md-3 text-center">
              Notas
            </div>
          </div>

          <div class="row">
            <div class="form-group col-md-3">
              <strong>Enterado</strong>
            </div>
            <div class="form-group col-md-3">
              <span>&nbsp;</span>
            </div>
            <div class="form-group col-md-3">
              <span>&nbsp;</span>
            </div>
            <div class="form-group col-md-3 text-center">
              <input type="checkbox" formControlName="notas1">
            </div>
          </div>

          <div class="row">
            <div class="form-group col-md-3">
              <strong>Inicio</strong>
            </div>
            <div class="form-group col-md-3 text-center">
              <input type="checkbox" formControlName="ini1">
            </div>
            <div class="form-group col-md-3 text-center">
              <input type="checkbox" formControlName="ini2">
            </div>
            <div class="form-group col-md-3 text-center">
              <input type="checkbox" formControlName="notas2">
            </div>
          </div>

          <div class="row">
            <div class="form-group col-md-3">
              <strong>Termino</strong>
            </div>
            <div class="form-group col-md-3 text-center">
              <input type="checkbox" formControlName="term1">
            </div>
            <div class="form-group col-md-3 text-center">
              <input type="checkbox" formControlName="term2">
            </div>
            <div class="form-group col-md-3 text-center">
              <input type="checkbox" formControlName="notas3">
            </div>
          </div>
        </div>
      </div>
    </form>
  </div>

  <div class="modal-footer">
    <button class="btn btn-success" (click)="guardarForm(); c();" [disabled]="myFormGroup.invalid">
      <i class="fas fa-save mr-2"></i>Guardar
    </button>
    <button class="btn btn-secondary ml-1" (click)="c('Close click')">
      Cerrar
    </button>
  </div>
</ng-template>
